<template>
  <div class="student-page">
    <IntroSection :title="student_data.page_name || page_name" />

    <SectionTitle
      id="support"
      style="border-bottom: none"
      :title="student_data.student_support_header"
    />

    <div class="row">
      <div class="left">
        <h4>{{ student_data.bachelor_degree_header }}</h4>

        <div
          v-html="$replaceMediaPath(student_data.bachelor_degree_description)"
          class="rich-text"
        ></div>
      </div>

      <div class="right">
        <h4>{{ student_data.master_degree_header }}</h4>

        <div
          v-html="$replaceMediaPath(student_data.master_degree_description)"
          class="rich-text"
        ></div>
      </div>
    </div>

    <template v-if="student_resource_data.length > 0">
      <SectionTitle :title="student_data.student_resources_header" />

      <ProgramList :data="student_resource_data" />
    </template>

    <template v-if="student_committees.length > 0">
      <SectionTitle :title="student_data.section_header_1" />

      <PeopleList :data="student_committees" />
    </template>

    <template v-if="exchange_programs.length > 0">
      <SectionTitle title="Exchange program" />

      <ServiceList :services="exchange_programs" />
    </template>

    <!-- <div class="row">
      <div class="left">
        <h4>{{ "Scholarships" }}</h4>

        <FileList :data="scholarships" />
      </div>

      <div class="right">
        <h4>Exchange program</h4>

        <a
          :href="student_data.exchange_program_link"
          target="_blank"
          rel="noopener noreferrer"
          class="exchange-program"
        >
          <AppImg :src="exchange_program_image" />

          <div class="see-more">
            <h5>See more</h5>

            <client-only>
              <ArrowUpRight24 class="icon" />
            </client-only>
          </div>
        </a>
      </div>
    </div> -->
  </div>
</template>

<script>
import _ from "lodash";
import qs from "qs";
import { mapMutations } from "vuex";

export default {
  data() {
    return {
      page_name: "Student",
      student_data: {},
      student_resource_data: [],
      exchange_programs: [],
    };
  },
  head({ $config }) {
    return {
      title: `${this.page_name} - ${$config.title}`,
    };
  },
  computed: {
    exchange_program_image() {
      return (
        process.env.api_url +
        _.get(this.student_data, "exchange_program_image.data.attributes.url")
      );
    },
    bachelor_degree_file() {
      return (
        process.env.api_url +
        _.get(this.student_data, "bachelor_degree_file.data.attributes.url")
      );
    },
    master_degree_file() {
      return (
        process.env.api_url +
        _.get(this.student_data, "master_degree_file.data.attributes.url")
      );
    },
    student_committees() {
      let data = _.get(this.student_data, "student_committees.data");

      data = _.map(data, (d) => {
        return {
          id: d.id,
          th_name: _.get(d, "attributes.th_name"),
          en_name: _.get(d, "attributes.en_name"),
          position: _.get(d, "attributes.program"),
          company: _.get(d, "attributes.company"),
          biography: _.get(d, "attributes.biography"),
          image:
            process.env.api_url +
            _.get(d, "attributes.photo.data.attributes.url"),
        };
      });

      return _.orderBy(data, "id", "asc");
    },
    scholarships() {
      let data = _.get(this.student_data, "scholarships.data");

      data = _.map(data, (d) => {
        return {
          name: _.get(d, "attributes.name"),
          file:
            process.env.api_url +
            _.get(d, "attributes.file.data.attributes.url"),
        };
      });

      return data;
    },
    _() {
      return _;
    },
  },
  async mounted() {
    this.setAppLoading(true);
    await Promise.all([
      this.getStudentData(),
      this.getStudentResource(),
      this.getExchangePrograms(),
    ]);
    this.setAppLoading(false);
  },
  methods: {
    ...mapMutations(["setAppLoading"]),
    async getStudentData() {
      const query = qs.stringify(
        {
          populate: [
            "bachelor_degree_file",
            "master_degree_file",
            "student_committees.photo",
            "scholarships",
            "exchange_programs",
            "exchange_programs.image",
          ],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/student?${query}`);
        this.student_data = _.get(res, "data.attributes") || {};
      } catch (error) {
        console.log("getStudentData ~ error:", error);
      }
    },
    async getStudentResource() {
      const query = qs.stringify(
        {
          populate: "*",
          pagination: {
            limit: 200,
          },
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/student-resources?${query}`);
        let data = _.get(res, "data");

        this.student_resource_data = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.resource_name"),
            url: _.get(d, "attributes.link"),
            image:
              process.env.api_url +
              _.get(d, "attributes.image.data.attributes.url"),
            link_type: "external",
          };
        });
      } catch (error) {
        console.log("getStudentResource ~ error:", error);
      }
    },
    async getExchangePrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          sort: ["id:asc"],
          pagination: {
            limit: 10,
          },
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/exchange-programs?${query}`);
        let data = _.get(res, "data");

        this.exchange_programs = _.map(data, (d) => {
          return {
            ...d,
            url:
              _.get(d, "attributes.type") === "internal"
                ? `/exchange-program/${d.id}`
                : _.get(d, "attributes.link"),
          };
        });
      } catch (error) {
        console.log("getExchangePrograms ~ error:", error);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.student-page {
  .row {
    display: flex;
    flex-wrap: wrap;
    @include media-breakpoint(mobile) {
      display: block;
    }
    > div {
      width: 50%;
      padding: 80px;
      border-top: 1px solid $color-primary-500;
      @include media-breakpoint(mobile) {
        width: 100%;
        padding: 40px 24px;
      }
      .rich-text {
        margin-top: 40px;
      }
      .exchange-program {
        display: block;
        text-decoration: none;
        margin-top: 40px;
        img {
          width: 100%;
          height: 320px;
        }
        .see-more {
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-top: 16px;
          h5 {
            font-weight: normal;
          }
          .icon {
            color: $color-primary-500;
          }
        }
      }
    }
    .left {
      border-right: 1px solid $color-primary-500;
      @include media-breakpoint(mobile) {
        border-right: none;
      }
    }
  }
}
</style>
